# Dart lib for duniter cryptography and APIs

## Description
Here is the common library which will facilitate your creation of [Ğ1 libre currency](https://monnaie-libre.fr/) client in Dart/Flutter, or any other cryptocurrency generated by [Duniter](https://duniter.org/).

For the moment, it only contains the methods essential for the operation of the [Ğecko](https://git.duniter.org/clients/gecko) client.
Other methods will emerge there depending on the needs of Ğecko or any other client based on this library.

## Actual content

### Crypto
- Generated BIP39 mnemonic in english, french, spanish or italian
- Create HD wallets based on BIP32 ED25519 cryptography
- Create [Cesium](https://cesium.app/) type wallets with salt + password, based on scrypt and ED25519 cryptography
- Generate [DEWIF](https://git.duniter.org/documents/rfcs/blob/master/rfc/0013_Duniter_Encrypted_Wallet_Import_Format.md) encrypted wallet, using scrypt and XOR cypher as describe in [RFC 13](https://git.duniter.org/documents/rfcs/blob/master/rfc/0013_Duniter_Encrypted_Wallet_Import_Format.md). Ready to store on filesystem.
- Decrypt DEWIF wallets with the given correct secret code
- Sign and verify signature for both HD wallets and Cesium wallets

### GVA
- Get account balance
- Get account username
- Pay with HD wallets
- Pay with Cesium wallets

### Cesium+
- TODO